import adapter from '@sveltejs/adapter-node';
import preprocess from 'svelte-preprocess';

/** @type {import('@sveltejs/kit').Config} */
const config = {
	preprocess: [
		preprocess({
			postcss: true
		})
	],

	kit: {
		adapter: adapter(),

		files: {
			assets: 'static',
			hooks: 'web_src/hooks',
			lib: 'web_src/lib',
			routes: 'web_src/routes',
			template: 'web_src/app.html'
		},

		vite: {
			server: {
				fs: {
					allow: ['./web_src']
				}
			}
		}
	}
};

export default config;
